/* DC9 update
 Esto es requerido por Dynamic C versin 9, para utilizar
una IP fija en programa y la interfaz Ethernet por defecto.
No es necesario en DC8, se autodefinen en las libs */
#define TCPCONFIG 0
#define USE_ETHERNET		1
/* Fin DC9 update */


#define MY_IP_ADDRESS   "192.168.1.54"
#define MY_NETMASK      "255.255.255.0"

#define MY_GATEWAY		"192.168.1.1"


#ximport "index.shtml"    index_html
#ximport "rabbit1.gif"    rabbit1_gif

#define HTTP_VERBOSE

#memmap xmem
#use "dcrtcp.lib"
#use "http.lib"

const HttpType http_types[] =
{
   { ".shtml", "text/html", shtml_handler}, // ssi
   { ".html", "text/html", NULL},           // html
   { ".cgi", "", NULL},                     // cgi
   { ".gif", "image/gif", NULL}
};

int myinc(HttpState* state);
int myreset(HttpState* state);

int mycounter;

const static HttpSpec http_flashspec[] =
{
   { HTTPSPEC_FILE,  "/",              index_html,    NULL, 0, NULL, NULL},
   { HTTPSPEC_FILE,  "/index.shtml",   index_html,    NULL, 0, NULL, NULL},
   { HTTPSPEC_FILE,  "/rabbit1.gif",   rabbit1_gif,   NULL, 0, NULL, NULL},

   { HTTPSPEC_VARIABLE, "counter", 	 0,  &mycounter, INT16, "%d", NULL},

   { HTTPSPEC_FUNCTION, "inc.cgi",	 0,  myinc, 	0, NULL, NULL},
   { HTTPSPEC_FUNCTION, "reset.cgi", 0,  myreset, 	0, NULL, NULL}
};

#define REDIRECTHOST		"http://" MY_IP_ADDRESS "/"

myinc(HttpState* state)
{
	mycounter++;
	cgi_redirectto(state,REDIRECTHOST);
   return(0);
}

myreset(HttpState* state)
{
	mycounter=0;
	cgi_redirectto(state,REDIRECTHOST);
   return(0);
}

main()
{
	mycounter=0;
	sock_init();
	http_init();
   while(1){
   	http_handler();
	}
}

