/* Estos ejemplos usan port A en vez de port B como en el libro, a fin de
permitir su rpido chequeo utilizando el mismo cable que para programacin
(consultar en el manual del core module la forma de conexin el cable,
en caso de ser necesario)
*/

#class auto
// Define tamao de buffers (2^n-1)
#define AINBUFSIZE  15
#define AOUTBUFSIZE 15
// Timeout de funcin (10 segs desde el ltimo caracter recibido)
#define MSSG_TMOUT 10000UL
// Timeout de programa (30 segundos sin recibir nada)
#define IDLE_TMOUT 30000UL

void main()
{
unsigned long t;
int n,i;
unsigned char indata[21];
unsigned char replydata[256];
static const char Fox[]="The quick brown fox jumps over the lazy dog 01234567890\r\n";

	WrPortI ( SPCR, &SPCRShadow, 0x84 );		// PA0-7 = Outputs
	n = 0;
	serAopen(1200);
	loopinit();
	for (;;) {
	    loophead();
	    costate {					// Recepcin
   		t = MS_TIMER;
   		wfd n = cof_serAread(indata, sizeof(indata)-1, MSSG_TMOUT);
			if(n!=(sizeof(indata)-1)){
	        	indata[n]=0;
				sprintf (replydata,"\r\n>> Timeout, %d caracteres recibidos: %s\r\n",n,indata);
         }
			else {
           	indata[sizeof(indata)-1]=0;
   	      sprintf (replydata,"\r\n>> Rx: %s\r\n",indata);
         }
			wfd cof_serAwrite(replydata, strlen(replydata)); // mensaje
	    }
  	    costate {					// Transmisin
			waitfor(DelayMs(250));
	   	wfd cof_serAwrite(Fox, sizeof(Fox));
			BitWrPortI( PADR, &PADRShadow, (PADRShadow&2)^2, 1 ); // toggle LED 3
	    }
	    costate {					// Rx timeout
    		if (MS_TIMER > t + IDLE_TMOUT){
    			t = MS_TIMER;
    			sprintf(replydata,"\r\n>> Inactivo\r\n");
				wfd cof_serAwrite(replydata, strlen(replydata)); // mensaje
    		}
	    }
	    costate {					// Tarea ficticia
			waitfor(DelayMs(50));
			BitWrPortI( PADR, &PADRShadow, (PADRShadow&1)^1, 0); // toggle LED 2
	    }
	}
	while (serAwrFree() != AOUTBUFSIZE);		// espera vaciar buffer de Tx
	serAclose();					// cierra port
}

